#This scripts reads the training data generated by the script Intersect_Bins_And_TF_Predictions.py.
#It casts all entries to a numeric value, and replaces "." entries by 0.0.
#To allow for faster reading in R, the data is stored as .RData files

#arg1 Path to the folder containing the Training Data split into TF specific subfolders, e.g.:
#TrainingData/CTCF, TrainingData/REST and so on. 
#arg2 Directory to save the RData files to.

args<-commandArgs(TRUE)

if (length(args)!=2){
  stop("Usage: <Path to the training data subfolders divided by TF> <Destination path>")
}else{
tfs<-list.files(path=args[1])
tissues<-list()
for (i in seq(length(tfs))){
  tissues[[i]]<-list.files(path=paste(args[1],tfs[i],"/",sep=""))
}

for (i in seq(length(tfs))){
  allfTFs_X <- list()
  allfTFs_Y <- list()
  features<-list()
  response<-list()
  for (j in seq(length(tissues[i][[1]]))){
   print(paste("Processing TF",tfs[i]," "))
   temp<-read.table(paste(args[1],paste(tfs[i],tissues[i][[1]][j],sep="/"),sep=""),header=TRUE,stringsAsFactors=FALSE,row.names=1)
   print("Done reading file!")
   response[[j]]<-temp$response           
   temp$response <- NULL
   features[[j]]<-temp
   allfTFs_X[[1]]<-features
   allfTFs_Y[[1]]<-response
   save(allfTFs_X,file=paste(paste(args[2],tfs[i],sep="/"),"_Features_Training.RData",sep=""))
   save(allfTFs_Y,file=paste(paste(args[2],tfs[i],sep="/"),"_Response_Training.RData",sep=""))
  }
}
}
